diff --git a/src/main/java/net/minecraft/core/enums/EnumSignPicture.java b/src/main/java/net/minecraft/core/enums/EnumSignPicture.java
index f99667a57..1b342c853 100644
--- a/src/main/java/net/minecraft/core/enums/EnumSignPicture.java
+++ b/src/main/java/net/minecraft/core/enums/EnumSignPicture.java
@@ -2,59 +2,57 @@ package net.minecraft.core.enums;
 
 public enum EnumSignPicture
 {
-    NONE(0, "sign.image.none", 48 * 0, 24 * 0),
-    ARROW_RIGHT(1, "sign.image.arrow_right", 48 * 1, 24 * 0),
-    ARROW_LEFT(2, "sign.image.arrow_left", 48 * 2, 24 * 0),
-    ARROW_DOWN(3, "sign.image.arrow_down", 48 * 3, 24 * 0),
-    ARROW_UP(4, "sign.image.arrow_up", 48 * 4, 24 * 0),
-    CAUTION(5, "sign.image.caution", 48 * 5, 24 * 0),
-    MOBS(6, "sign.image.mobs", 48 * 6, 24 * 0),
-    TREES(7, "sign.image.trees", 48 * 7, 24 * 0),
-    CHEST(8, "sign.image.chest", 48 * 8, 24 * 0),
-    PICKAXE(9, "sign.image.pickaxe", 48 * 9, 24 * 0),
-    WOLF(10, "sign.image.wolf", 48 * 10, 24 * 0),
-    SWORD(11, "sign.image.sword", 48 * 11, 24 * 0),
-    HOE(12, "sign.image.hoe", 48 * 12, 24 * 0),
-    AXE(13, "sign.image.axe", 48 * 13, 24 * 0),
-    SHOVEL(14, "sign.image.shovel", 48 * 14, 24 * 0),
-    BOWL(15, "sign.image.bowl", 48 * 15, 24 * 0),
-    TNT(16, "sign.image.tnt", 48 * 0, 24 * 1),
-    MOB_FARM(17, "sign.image.mob_farm", 48 * 1, 24 * 1),
-    MINE(18, "sign.image.mine", 48 * 2, 24 * 1),
-    REDSTONE(19, "sign.image.redstone", 48 * 3, 24 * 1),
-    FARM(20, "sign.image.farm", 48 * 4, 24 * 1),
-    BARRICADE(21, "sign.image.barricade", 48 * 5, 24 * 1),
-    QUESTION_MARK(22, "sign.image.question_mark", 48 * 6, 24 * 1),
-    FACE_SMILE(23, "sign.image.face_smile", 48 * 7, 24 * 1),
-    FACE_SAD(24, "sign.image.face_sad", 48 * 8, 24 * 1),
-    FACE_CRYING(25, "sign.image.face_crying", 48 * 9, 24 * 1),
-    FACE_GASP(26, "sign.image.face_gasp", 48 * 10, 24 * 1),
-    FACE_THINKING(27, "sign.image.face_thinking", 48 * 11, 24 * 1),
-    FACE_CONFUSED(28, "sign.image.face_confused", 48 * 12, 24 * 1),
-    BIG_SIGN(29, "sign.image.big_sign", 48 * 13, 24 * 1),
-    MOB_ZOMBIE(30, "sign.image.mob_zombie", 48 * 14, 24 * 1),
-    MOB_SKELETON(31, "sign.image.mob_skeleton", 48 * 15, 24 * 1),
-    MOB_CREEPER(32, "sign.image.mob_creeper", 48 * 0, 24 * 2),
-    ONE_PLAYER(33, "sign.image.one_player", 48 * 1, 24 * 2),
-    TWO_PLAYERS(34, "sign.image.two_players", 48 * 2, 24 * 2),
-    THREE_PLAYERS(35, "sign.image.three_players", 48 * 3, 24 * 2),
-    CROSS(36, "sign.image.cross", 48 * 4, 24 * 2),
-    CRAFT(37, "sign.image.craft", 48 * 5, 24 * 2),
-    AFK(38, "sign.image.afk", 48 * 6, 24 * 2),
-    BRB(39, "sign.image.brb", 48 * 7, 24 * 2),
-    HEART(40, "sign.image.heart", 48 * 8, 24 * 2);
+    NONE            (0,  "sign.image.none",          "minecraft:sign/none"),
+    ARROW_RIGHT     (1,  "sign.image.arrow_right",   "minecraft:sign/arrow_right"),
+    ARROW_LEFT      (2,  "sign.image.arrow_left",    "minecraft:sign/arrow_left"),
+    ARROW_DOWN      (3,  "sign.image.arrow_down",    "minecraft:sign/arrow_down"),
+    ARROW_UP        (4,  "sign.image.arrow_up",      "minecraft:sign/arrow_up"),
+    CAUTION         (5,  "sign.image.caution",       "minecraft:sign/caution"),
+    MOBS            (6,  "sign.image.mobs",          "minecraft:sign/mobs"),
+    TREES           (7,  "sign.image.trees",         "minecraft:sign/trees"),
+    CHEST           (8,  "sign.image.chest",         "minecraft:sign/chest"),
+    PICKAXE         (9,  "sign.image.pickaxe",       "minecraft:sign/pickaxe"),
+    WOLF            (10, "sign.image.wolf",          "minecraft:sign/wolf"),
+    SWORD           (11, "sign.image.sword",         "minecraft:sign/sword"),
+    HOE             (12, "sign.image.hoe",           "minecraft:sign/hoe"),
+    AXE             (13, "sign.image.axe",           "minecraft:sign/axe"),
+    SHOVEL          (14, "sign.image.shovel",        "minecraft:sign/shovel"),
+    BOWL            (15, "sign.image.bowl",          "minecraft:sign/bowl"),
+    TNT             (16, "sign.image.tnt",           "minecraft:sign/tnt"),
+    MOB_FARM        (17, "sign.image.mob_farm",      "minecraft:sign/mob_farm"),
+    MINE            (18, "sign.image.mine",          "minecraft:sign/mine"),
+    REDSTONE        (19, "sign.image.redstone",      "minecraft:sign/redstone"),
+    FARM            (20, "sign.image.farm",          "minecraft:sign/farm"),
+    BARRICADE       (21, "sign.image.barricade",     "minecraft:sign/barricade"),
+    QUESTION_MARK   (22, "sign.image.question_mark", "minecraft:sign/question_mark"),
+    FACE_SMILE      (23, "sign.image.face_smile",    "minecraft:sign/face_smile"),
+    FACE_SAD        (24, "sign.image.face_sad",      "minecraft:sign/face_sad"),
+    FACE_CRYING     (25, "sign.image.face_crying",   "minecraft:sign/face_crying"),
+    FACE_GASP       (26, "sign.image.face_gasp",     "minecraft:sign/face_gasp"),
+    FACE_THINKING   (27, "sign.image.face_thinking", "minecraft:sign/face_thinking"),
+    FACE_CONFUSED   (28, "sign.image.face_confused", "minecraft:sign/face_confused"),
+    BIG_SIGN        (29, "sign.image.big_sign",      "minecraft:sign/big_sign"),
+    MOB_ZOMBIE      (30, "sign.image.mob_zombie",    "minecraft:sign/mob_zombie"),
+    MOB_SKELETON    (31, "sign.image.mob_skeleton",  "minecraft:sign/mob_skeleton"),
+    MOB_CREEPER     (32, "sign.image.mob_creeper",   "minecraft:sign/mob_creeper"),
+    ONE_PLAYER      (33, "sign.image.one_player",    "minecraft:sign/one_player"),
+    TWO_PLAYERS     (34, "sign.image.two_players",   "minecraft:sign/two_players"),
+    THREE_PLAYERS   (35, "sign.image.three_players", "minecraft:sign/three_players"),
+    CROSS           (36, "sign.image.cross",         "minecraft:sign/cross"),
+    CRAFT           (37, "sign.image.craft",         "minecraft:sign/craft"),
+    AFK             (38, "sign.image.afk",           "minecraft:sign/afk"),
+    BRB             (39, "sign.image.brb",           "minecraft:sign/brb"),
+    HEART           (40, "sign.image.heart",         "minecraft:sign/heart");
 
     private final int id;
     private final String languageKey;
-    private final int u;
-    private final int v;
+    private final String texKey;
 
-    EnumSignPicture(int id, String languageKey, int u, int v)
+    EnumSignPicture(int id, String languageKey, String textureKey)
     {
         this.id = id;
         this.languageKey = languageKey;
-        this.u = u;
-        this.v = v;
+        this.texKey = textureKey;
     }
 
     public int getId()
@@ -67,13 +65,8 @@ public enum EnumSignPicture
         return languageKey;
     }
 
-    public int getU()
+    public String getTextureKey()
     {
-        return u;
-    }
-
-    public int getV()
-    {
-        return v;
+        return texKey;
     }
 }
diff --git a/src/main/java/net/minecraft/core/enums/MobCategory.java b/src/main/java/net/minecraft/core/enums/MobCategory.java
new file mode 100644
index 000000000..4ac9289a7
--- /dev/null
+++ b/src/main/java/net/minecraft/core/enums/MobCategory.java
@@ -0,0 +1,43 @@
+package net.minecraft.core.enums;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.animal.Animal;
+import net.minecraft.core.entity.animal.WaterAnimal;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.monster.Enemy;
+
+public enum MobCategory {
+
+	monster("monster", 0, Enemy.class, 70, Material.air, false),
+    creature("creature", 1, Animal.class, 15, Material.air, true),
+    waterCreature("waterCreature", 2, WaterAnimal.class, 5, Material.water, true),
+    ambientCreature("ambient", 3, Entity.class, 2, Material.air, true);
+	
+	private final Class<?> baseClass;
+	private final int maxPerChunk;
+	private final Material spawnMaterial;
+	private final boolean isPeaceful;
+
+	MobCategory(String name, int id, Class<?> baseClass, int maxPerChunk, Material spawnMaterial, boolean isPeaceful) {
+		this.baseClass = baseClass;
+		this.maxPerChunk = maxPerChunk;
+		this.spawnMaterial = spawnMaterial;
+		this.isPeaceful = isPeaceful;
+	}
+
+	public Class<?> getBaseClass() {
+		return baseClass;
+	}
+
+	public int getMaxCreaturesPerChunk() {
+		return maxPerChunk;
+	}
+
+	public Material getSpawnMaterial() {
+		return spawnMaterial;
+	}
+
+	public boolean isPeaceful() {
+		return isPeaceful;
+	}
+}
diff --git a/src/main/java/net/minecraft/core/item/ArmorItem.java b/src/main/java/net/minecraft/core/item/ArmorItem.java
new file mode 100644
index 000000000..7f86ad5b6
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/ArmorItem.java
@@ -0,0 +1,27 @@
+package net.minecraft.core.item;
+
+import net.minecraft.core.item.material.ArmorMaterial;
+
+public class ArmorItem extends Item implements IArmorItem {
+	private final ArmorMaterial material;
+	private final int armorPiece;
+	public ArmorItem(String name, String namespaceId, int id, ArmorMaterial material, int armorPiece) {
+		super(name, namespaceId, id);
+		this.material = material;
+		this.armorPiece = armorPiece;
+		
+		setMaxDamage((int)(ARMOR_PIECE_DURABILITY_MODIFIERS[armorPiece] * material.durability));
+		
+		maxStackSize = 1;
+	}
+	@Override
+	public ArmorMaterial getArmorMaterial() {
+		return material;
+	}
+
+	@Override
+	public int getArmorPiece() {
+		return armorPiece;
+	}
+
+}
diff --git a/src/main/java/net/minecraft/core/item/ItemBed.java b/src/main/java/net/minecraft/core/item/BedItem.java
similarity index 76%
rename from src/main/java/net/minecraft/core/item/ItemBed.java
rename to src/main/java/net/minecraft/core/item/BedItem.java
index 380fc57de..910657533 100644
--- a/src/main/java/net/minecraft/core/item/ItemBed.java
+++ b/src/main/java/net/minecraft/core/item/BedItem.java
@@ -1,34 +1,34 @@
 package net.minecraft.core.item;
 
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockBed;
+import net.minecraft.core.block.BedBlock;
+import net.minecraft.core.block.Blocks;
 
 // Referenced classes of package net.minecraft.src:
-//            Item, Block, BlockBed, EntityPlayer, 
+//            Item, Block, BedBlock, Player,
 //            MathHelper, World, ItemStack
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class ItemBed extends Item
+public class BedItem extends Item
 {
 
-    public ItemBed(String name, int id)
+    public BedItem(String name, String namespaceId, int id)
     {
-        super(name, id);
+        super(name, namespaceId, id);
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
     	if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
     		blockX += side.getOffsetX();
     		blockY += side.getOffsetY();
     		blockZ += side.getOffsetZ();
     	}
-        BlockBed blockbed = (BlockBed) Block.bed;
+        BedBlock blockbed = (BedBlock) Blocks.BED;
         int i1 = entityplayer.getHorizontalPlacementDirection(null).getOpposite().getHorizontalIndex();
         byte byte0 = 0;
         byte byte1 = 0;
diff --git a/src/main/java/net/minecraft/core/item/ItemBoat.java b/src/main/java/net/minecraft/core/item/BoatItem.java
similarity index 66%
rename from src/main/java/net/minecraft/core/item/ItemBoat.java
rename to src/main/java/net/minecraft/core/item/BoatItem.java
index cbea601c3..3dbe8f6b4 100644
--- a/src/main/java/net/minecraft/core/item/ItemBoat.java
+++ b/src/main/java/net/minecraft/core/item/BoatItem.java
@@ -2,29 +2,29 @@ package net.minecraft.core.item;
 
 
 // Referenced classes of package net.minecraft.src:
-//            Item, EntityPlayer, Vec3D, MathHelper, 
+//            Item, Player, Vec3D, MathHelper,
 //            World, MovingObjectPosition, EnumMovingObjectType, Block, 
-//            EntityBoat, ItemStack
+//            BoatEntity, ItemStack
 
-import net.minecraft.core.entity.vehicle.EntityBoat;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.vehicle.BoatEntity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.HitResult;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 
-public class ItemBoat extends Item
+public class BoatItem extends Item
 {
 
-    public ItemBoat(String name, int id)
+    public BoatItem(String name, String namespaceId, int id)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         maxStackSize = 1;
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
     {
         float f = 1.0F;
         float f1 = entityplayer.xRotO + (entityplayer.xRot - entityplayer.xRotO) * f;
@@ -32,16 +32,16 @@ public class ItemBoat extends Item
         double d = entityplayer.xo + (entityplayer.x - entityplayer.xo) * (double)f;
         double d1 = (entityplayer.yo + (entityplayer.y - entityplayer.yo) * (double)f + 1.62D) - (double)entityplayer.heightOffset;
         double d2 = entityplayer.zo + (entityplayer.z - entityplayer.zo) * (double)f;
-        Vec3d vec3d = Vec3d.createVector(d, d1, d2);
-        float f3 = MathHelper.cos(-f2 * 0.01745329F - 3.141593F);
-        float f4 = MathHelper.sin(-f2 * 0.01745329F - 3.141593F);
+        Vec3 vec3 = Vec3.getTempVec3(d, d1, d2);
+        float f3 = MathHelper.cos(-f2 * 0.01745329F - MathHelper.PI);
+        float f4 = MathHelper.sin(-f2 * 0.01745329F - MathHelper.PI);
         float f5 = -MathHelper.cos(-f1 * 0.01745329F);
         float f6 = MathHelper.sin(-f1 * 0.01745329F);
         float f7 = f4 * f5;
         float f9 = f3 * f5;
         double d3 = 5D;
-        Vec3d vec3d1 = vec3d.addVector((double)f7 * d3, (double) f6 * d3, (double)f9 * d3);
-        HitResult movingobjectposition = world.checkBlockCollisionBetweenPoints(vec3d, vec3d1, true);
+        Vec3 vec31 = vec3.add((double)f7 * d3, (double) f6 * d3, (double)f9 * d3);
+        HitResult movingobjectposition = world.checkBlockCollisionBetweenPoints(vec3, vec31, true);
         if(movingobjectposition == null)
         {
             return itemstack;
@@ -53,11 +53,11 @@ public class ItemBoat extends Item
             int k = movingobjectposition.z;
             if(!world.isClientSide)
             {
-                if(world.getBlockId(i, j, k) == Block.layerSnow.id)
+                if(world.getBlockId(i, j, k) == Blocks.LAYER_SNOW.id)
                 {
                     j--;
                 }
-                EntityBoat boat = new EntityBoat(world, (float)i + 0.5F, (float)j + 1.0F, (float)k + 0.5F);
+                BoatEntity boat = new BoatEntity(world, (float)i + 0.5F, (float)j + 1.0F, (float)k + 0.5F);
                 boat.setRot(entityplayer.yRot - 90, 0);
                 world.entityJoinedWorld(boat);
             }
diff --git a/src/main/java/net/minecraft/core/item/ItemBow.java b/src/main/java/net/minecraft/core/item/BowItem.java
similarity index 58%
rename from src/main/java/net/minecraft/core/item/ItemBow.java
rename to src/main/java/net/minecraft/core/item/BowItem.java
index ccedc20be..a1a7260f8 100644
--- a/src/main/java/net/minecraft/core/item/ItemBow.java
+++ b/src/main/java/net/minecraft/core/item/BowItem.java
@@ -2,60 +2,60 @@
 package net.minecraft.core.item;
 
 // Referenced classes of package net.minecraft.src:
-//            Item, EntityPlayer, InventoryPlayer, World, 
-//            EntityArrow, ItemStack
+//            Item, Player, InventoryPlayer, World,
+//            ArrowProjectile, ItemStack
 
-import net.minecraft.core.entity.projectile.EntityArrow;
-import net.minecraft.core.entity.projectile.EntityArrowGolden;
-import net.minecraft.core.entity.projectile.EntityArrowPurple;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.projectile.ArrowProjectile;
+import net.minecraft.core.entity.projectile.ArrowProjectileGolden;
+import net.minecraft.core.entity.projectile.ArrowProjectilePurple;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
 
-public class ItemBow extends Item
+public class BowItem extends Item
 {
 
-    public ItemBow(String name, int id)
+    public BowItem(String name, String namespaceId, int id)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         maxStackSize = 1;
         setMaxDamage(384);
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
     {
         ItemStack quiverSlot = entityplayer.inventory.armorItemInSlot(2);
-        if(quiverSlot != null && quiverSlot.itemID == Item.armorQuiver.id && quiverSlot.getMetadata() < quiverSlot.getMaxDamage()){
+        if(quiverSlot != null && quiverSlot.itemID == Items.ARMOR_QUIVER.id && quiverSlot.getMetadata() < quiverSlot.getMaxDamage()){
             entityplayer.inventory.armorItemInSlot(2).damageItem(1, entityplayer);
             itemstack.damageItem(1, entityplayer);
             world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.3f, 1.0F / (itemRand.nextFloat() * 0.4F + 0.8F));
             if (!world.isClientSide) {
-                world.entityJoinedWorld(new EntityArrow(world, entityplayer, true, 0));
+                world.entityJoinedWorld(new ArrowProjectile(world, entityplayer, true, 0));
             }
         }
-        else if(quiverSlot != null && quiverSlot.itemID == Item.armorQuiverGold.id){
+        else if(quiverSlot != null && quiverSlot.itemID == Items.ARMOR_QUIVER_GOLD.id){
             itemstack.damageItem(1, entityplayer);
             world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.3f, 1.0F / (itemRand.nextFloat() * 0.4F + 0.8F));
             if (!world.isClientSide) {
-                world.entityJoinedWorld(new EntityArrowPurple(world, entityplayer, false));
+                world.entityJoinedWorld(new ArrowProjectilePurple(world, entityplayer, false));
             }
         }
-        else if (entityplayer.inventory.consumeInventoryItem(Item.ammoArrowGold.id))
+        else if (entityplayer.inventory.consumeInventoryItem(Items.AMMO_ARROW_GOLD.id))
         {
             itemstack.damageItem(1, entityplayer);
             world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.3f, 1.0F / (itemRand.nextFloat() * 0.4F + 0.8F));
             if(!world.isClientSide)
             {
-                world.entityJoinedWorld(new EntityArrowGolden(world, entityplayer, true));
+                world.entityJoinedWorld(new ArrowProjectileGolden(world, entityplayer, true));
             }
         }
-        else if(entityplayer.inventory.consumeInventoryItem(Item.ammoArrow.id))
+        else if(entityplayer.inventory.consumeInventoryItem(Items.AMMO_ARROW.id))
         {
             itemstack.damageItem(1, entityplayer);
             world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.3f, 1.0F / (itemRand.nextFloat() * 0.4F + 0.8F));
             if(!world.isClientSide)
             {
-                world.entityJoinedWorld(new EntityArrow(world, entityplayer, true, 0));
+                world.entityJoinedWorld(new ArrowProjectile(world, entityplayer, true, 0));
             }
         }
         return itemstack;
diff --git a/src/main/java/net/minecraft/core/item/ItemBucket.java b/src/main/java/net/minecraft/core/item/BucketItem.java
similarity index 74%
rename from src/main/java/net/minecraft/core/item/ItemBucket.java
rename to src/main/java/net/minecraft/core/item/BucketItem.java
index 5c8e2672b..b457c85eb 100644
--- a/src/main/java/net/minecraft/core/item/ItemBucket.java
+++ b/src/main/java/net/minecraft/core/item/BucketItem.java
@@ -1,29 +1,30 @@
 package net.minecraft.core.item;
 
 // Referenced classes of package net.minecraft.src:
-//            Item, EntityPlayer, Vec3D, MathHelper, 
+//            Item, Player, Vec3D, MathHelper,
 //            World, MovingObjectPosition, EnumMovingObjectType, Material, 
-//            ItemStack, WorldProvider, Block, EntityCow
+//            ItemStack, WorldProvider, Block, CowMob
 
-import net.minecraft.core.HitResult;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
-import net.minecraft.server.entity.player.EntityPlayerMP;
+import net.minecraft.server.entity.player.ServerPlayer;
 
-public class ItemBucket extends Item
+public class BucketItem extends Item
 {
 
-    public ItemBucket(String name, int id, Block blockToPlace)
+    public BucketItem(String name, String namespaceId, int id, Block blockToPlace)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         maxStackSize = 1;
         if (blockToPlace == null)
         {
@@ -36,15 +37,15 @@ public class ItemBucket extends Item
     }
 
     @Override
-	public ItemStack onUseItem(ItemStack stack, World world, EntityPlayer player) {
+	public ItemStack onUseItem(ItemStack stack, World world, Player player) {
 		float f = 1.0F;
 		float f1 = player.xRotO + (player.xRot - player.xRotO) * f;
 		float f2 = player.yRotO + (player.yRot - player.yRotO) * f;
 		double posX = player.xo + (player.x - player.xo) * (double) f;
-		float yOff = player instanceof EntityPlayerMP ? player.getHeightOffset() : 0;
+		float yOff = player instanceof ServerPlayer ? player.getHeightOffset() : 0;
 		double posY = (player.yo + (player.y - player.yo)) + yOff;
 		double posZ = player.zo + (player.z - player.zo) * (double) f;
-		Vec3d vec3d = Vec3d.createVector(posX, posY, posZ);
+		Vec3 vec3 = Vec3.getTempVec3(posX, posY, posZ);
 		float f3 = MathHelper.cos(-f2 * 0.01745329F - MathHelper.PI);
 		float f4 = MathHelper.sin(-f2 * 0.01745329F - MathHelper.PI);
 		float f5 = -MathHelper.cos(-f1 * 0.01745329F);
@@ -53,8 +54,8 @@ public class ItemBucket extends Item
 		float f8 = f6;
 		float f9 = f3 * f5;
 		double reachDistance = player.getGamemode().getBlockReachDistance();
-		Vec3d vec3d1 = vec3d.addVector((double) f7 * reachDistance, (double) f8 * reachDistance, (double) f9 * reachDistance);
-		HitResult rayTraceResult = world.checkBlockCollisionBetweenPoints(vec3d, vec3d1, idToPlace == 0);
+		Vec3 vec31 = vec3.add((double) f7 * reachDistance, (double) f8 * reachDistance, (double) f9 * reachDistance);
+		HitResult rayTraceResult = world.checkBlockCollisionBetweenPoints(vec3, vec31, idToPlace == 0);
 		
 		if(rayTraceResult == null || rayTraceResult.hitType != HitResult.HitType.TILE) {
 			return stack;
@@ -70,7 +71,7 @@ public class ItemBucket extends Item
 		
 		if(idToPlace < 0) {
 			// Milk
-			return new ItemStack(Item.bucket);
+			return new ItemStack(Items.BUCKET);
 		}
 		
 		Block block = world.getBlock(x, y, z);
@@ -86,13 +87,13 @@ public class ItemBucket extends Item
 		}
 		
 		if(world.isAirBlock(x, y, z) || !world.getBlockMaterial(x, y, z).isSolid()) {
-			if(world.dimension == Dimension.nether && idToPlace == Block.fluidWaterFlowing.id) {
+			if(world.dimension == Dimension.nether && idToPlace == Blocks.FLUID_WATER_FLOWING.id) {
 				world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, z + 0.5, y + 0.5, x + 0.5, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
 				for (int l = 0; l < 8; l++) {
 					world.spawnParticle("largesmoke", x + Math.random(), y + Math.random(), z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
 				}
 			} else {
-				if(idToPlace == Block.fluidWaterFlowing.id) {
+				if(idToPlace == Blocks.FLUID_WATER_FLOWING.id) {
 					world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5F, y + 0.5F, z + 0.5F, "liquid.splash", 0.5f, 1.0f);
 				}
 				player.swingItem();
@@ -103,7 +104,7 @@ public class ItemBucket extends Item
 				world.setBlockAndMetadataWithNotify(x, y, z, idToPlace, 0);
 			}
 			if(player.getGamemode().consumeBlocks()) {
-				return new ItemStack(Item.bucket);
+				return new ItemStack(Items.BUCKET);
 			}
 		}
 
diff --git a/src/main/java/net/minecraft/core/item/ItemCoal.java b/src/main/java/net/minecraft/core/item/CoalItem.java
similarity index 76%
rename from src/main/java/net/minecraft/core/item/ItemCoal.java
rename to src/main/java/net/minecraft/core/item/CoalItem.java
index 4a291ee56..02a9136fe 100644
--- a/src/main/java/net/minecraft/core/item/ItemCoal.java
+++ b/src/main/java/net/minecraft/core/item/CoalItem.java
@@ -4,12 +4,12 @@ package net.minecraft.core.item;
 // Referenced classes of package net.minecraft.src:
 //            Item, ItemStack
 
-public class ItemCoal extends Item
+public class CoalItem extends Item
 {
 
-    public ItemCoal(String name, int id)
+    public CoalItem(String name, String namespaceId, int id)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         setHasSubtypes(true);
         setMaxDamage(0);
     }
diff --git a/src/main/java/net/minecraft/core/item/ItemDoor.java b/src/main/java/net/minecraft/core/item/DoorItem.java
similarity index 86%
rename from src/main/java/net/minecraft/core/item/ItemDoor.java
rename to src/main/java/net/minecraft/core/item/DoorItem.java
index c2db036d9..1f09354a2 100644
--- a/src/main/java/net/minecraft/core/item/ItemDoor.java
+++ b/src/main/java/net/minecraft/core/item/DoorItem.java
@@ -4,28 +4,28 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
 
 // Referenced classes of package net.minecraft.src:
-//            Item, Material, Block, EntityPlayer, 
+//            Item, Material, Block, Player,
 //            MathHelper, World, ItemStack
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class ItemDoor extends Item {
+public class DoorItem extends Item {
 	protected final Block doorBlockBottom;
 	protected final Block doorBlockTop;
 
-	public ItemDoor(String name, int id, Block doorBlockBottom, Block doorBlockTop) {
-		super(name, id);
+	public DoorItem(String name, String namespaceId, int id, Block doorBlockBottom, Block doorBlockTop) {
+		super(name, namespaceId, id);
 		maxStackSize = 64;
         this.doorBlockBottom = doorBlockBottom;
         this.doorBlockTop = doorBlockTop;
     }
 
 	@Override
-	public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
 			blockX += side.getOffsetX();
 			blockY += side.getOffsetY();
